(ns wanijo.visualisation.routes
  (:require [compojure.core :refer [defroutes wrap-routes
                                    GET POST DELETE]]
            [ring.util.response :as resp]
            [wanijo.framework.routing :refer [register! path]]
            [wanijo.instance.domain :as domain-instance]
            [wanijo.visualisation.viz :as viz]))

(defroutes routes
  (GET (register! :vis-single-instance "/visualisation/instance/:uuid")
       [uuid]
       {:body (viz/single-instance
               (domain-instance/full-instance-by-uuid! uuid))
        :headers {"Content-Type" "image/svg+xml"}}))
